'use strict'
require('./config.js');
let child_process = require('child_process');
let CronJob = require('cron').CronJob;
let job = new CronJob({
    cronTime: '0 0,15 * * * *',
    onTick: runAnalysis,
    start: false,
    timeZone: "Asia/Shanghai"
});

job.start();
runAnalysis();
function runAnalysis(){
    let date = new Date();
    let startTime = date.getTime();
    LOGGER.info('--------------------------------------------------------------');
    LOGGER.info('Analysis task start : ' + date);
    LOGGER.info('--------------------------------------------------------------');
    let task = child_process.fork('./analysis.js');
    task.on('close',function(){
        date = new Date();
        let runThrough = Math.floor((date.getTime()-startTime)/1000);
        LOGGER.info('--------------------------------------------------------------');
        LOGGER.info(`Analysis task finished in [ ${runThrough}s ]`);
        LOGGER.info('--------------------------------------------------------------');
    })
}